﻿#NoTrayIcon

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

; based on last post here https://autohotkey.com/board/topic/544-accent-hotkey-script/
; modified to match mac accents http://symbolcodes.tlt.psu.edu/accents/codemac.html
; commented 2017-03-15

; Table of letters to their accented versions
; Re-insert original letter if accent is not applicable

KEYS=aeiouncs
Coordmode,ToolTip,Screen
; letter:= [acute, grave, circumflex, umlaut, tilda, cedilla, ligature, eszett]
a:=	["á", "à", "â", "ä", "ã", "a", "æ", "a"]
capA:=	["Á", "À", "Â", "Ä", "Ã", "A", "Æ", "A"]
e:=	["é", "è", "ê", "ë", "e", "e", "e", "e"]
capE:=	["É", "È", "Ê", "Ë", "E", "E", "E", "E"]
i:=	["í", "ì", "î", "ï", "i", "i", "i", "i"]
capI:=	["Í", "Ì", "Î", "Ï", "I", "I", "I", "I"]
o:=	["ó", "ò", "ô", "ö", "õ", "o", "œ", "o"]
capO:=	["Ó", "Ò", "Ô", "Ö", "Õ", "O", "Œ", "O"]
u:=	["ú", "ù", "û", "ü", "u", "u", "u", "u"]
capU:=	["Ú", "Ù", "Û", "Ü", "U", "U", "U", "U"]
n:=	["n", "n", "n", "n", "ñ", "n", "n", "n"]
capN:=	["N", "N", "N", "N", "Ñ", "N", "N", "N"]
c:=	["c", "c", "c", "c", "c", "ç", "c", "c"]
capC:=	["C", "C", "C", "C", "C", "Ç", "C", "C"]
s:=	["s", "s", "s", "s", "s", "s", "s", "ß"]
capS:=	["S", "S", "S", "S", "S", "S", "S", "ß"]
RETURN

; Send the accent

ACCENT:
key:=IF GETKEYSTATE("CAPSLOCK","T") ? "+" a_thishotkey : a_thishotkey
KEY:=IF INSTR(KEY,"+") ? "cap" REGEXREPLACE(KEY,"\+") : KEY
gosub,off
send % "" %KEY%[CURRENT]
tooltip,
return

; Set accent state

f1::
reload
return

on:
loop,parse,keys
{
	HOTKEY,%a_loopfield%,ACCENT,ON
	hotkey,+%a_loopfield%,ACCENT,ON
}
return

off:
loop,parse,keys
{
	HOTKEY,%a_loopfield%,ACCENT,off
	hotkey,+%a_loopfield%,ACCENT,off
}
return

; Declare the hotkeys

#e::
accent("acute")
#`::
accent("grave")
#i::
accent("circumflex")
#u::
accent("umlaut")
#n::
accent("tilda")
#c::
accent("cedilla")
#x::
accent("ligature")
#s::
accent("eszett")

; accent function triggers tooltip and accent insertion sub

accent(accent){
	global
	TYPE:=["ACUTE", "GRAVE", "CIRCUMFLEX", "UMLAUT", "TILDA", "CEDILLA", "LIGATURE", "ESZETT"]
	FOR index,t IN TYPE
		IF t=%accent%
			CURRENTtype:=t,current:=a_index

	caret_x = %A_CaretX%
 	caret_y = %A_CaretY%
 	caret_y += 50

	tooltip,%currenttype%,caret_x,caret_y
	gosub,on
	exit
}

; extra accents

#8::
send •
return

#2::
send «
send % Chr(160)
return

#3::
send % Chr(160)
send »
return

#1::
send ¡
return

#/::
send ¿
return

#Space::
send % Chr(160)
return

#,::
send ✗
return

#.::
send ✓
return

#<::
send ☐
return

#>::
send ☑
return

#j::
send ¯\_(ツ)_/¯
return

#5::
send ⛤
return